/*
	Copyright (c) 2016 Jacob L. Farnsworth

	Permission is hereby granted, free of charge, to any person obtaining a copy
	of this software and associated documentation files (the "Software"), to deal
	in the Software without restriction, including without limitation the rights
	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
	of the Software, and to permit persons to whom the Software is furnished to do so,
	subject to the following conditions:

	The above copyright notice and this permission notice shall be included in all
	copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
	INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
	PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
	HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
	CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
	OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>
#include <stdio.h>
#include <commctrl.h>
#include <time.h>
#include "resource.h"
#include "main.h"

void ResetProgBar(HWND hwnd)
{
	SendDlgItemMessage(hwnd, IDC_OPENPROGRESS, PBM_SETRANGE, 0, 0x10000000);
	SendDlgItemMessage(hwnd, IDC_OPENPROGRESS, PBM_SETPOS, 0, 0);
}

void SetProgBar(HWND hwnd, int iPos)
{
	SendDlgItemMessage(hwnd, IDC_OPENPROGRESS, PBM_SETPOS, (WPARAM)iPos, 0);
}

BOOL CALLBACK MainDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
    switch(Message)
    {
        case WM_INITDIALOG:
			{
				EnableWindow(GetDlgItem(hwnd, IDC_CLOSE), false);
				EnableWindow(GetDlgItem(hwnd, IDC_SAVE), false);
				EnableWindow(GetDlgItem(hwnd, IDC_ADDCARGO), false);
				EnableWindow(GetDlgItem(hwnd, IDC_ADDEQUIP), false);
				EnableWindow(GetDlgItem(hwnd, IDC_EQUIP_HP), false);
				EnableWindow(GetDlgItem(hwnd, IDC_EQUIP_NICK), false);
				EnableWindow(GetDlgItem(hwnd, IDC_CARGO_NICK), false);
				EnableWindow(GetDlgItem(hwnd, IDC_CARGO_COUNT), false);
				EnableWindow(GetDlgItem(hwnd, IDC_MONEY), false);
				EnableWindow(GetDlgItem(hwnd, IDC_DESC), false);
				EnableWindow(GetDlgItem(hwnd, IDC_SHIPARCH), false);
				EnableWindow(GetDlgItem(hwnd, IDC_SYSTEM), false);
				EnableWindow(GetDlgItem(hwnd, IDC_BASE), false);
				EnableWindow(GetDlgItem(hwnd, IDC_RANK), false);
				EnableWindow(GetDlgItem(hwnd, IDC_CANDOCK), false);
				EnableWindow(GetDlgItem(hwnd, IDC_CANTL), false);
			}
			break;
        case WM_COMMAND:
            switch(LOWORD(wParam))
            {
                case IDOK:
				{
					char temp_path[MAX_PATH] = "";
					GetCurrentDirectory(MAX_PATH, temp_path);
					strcat(temp_path, "\\temp_save.fl");
					DeleteFile(temp_path);
                    EndDialog(hwnd, IDOK);
				}
				break;
				case IDCANCEL:
				{
					char temp_path[MAX_PATH] = "";
					GetCurrentDirectory(MAX_PATH, temp_path);
					strcat(temp_path, "\\temp_save.fl");
					DeleteFile(temp_path);
                    EndDialog(hwnd, IDCANCEL);
				}
                break;
				case IDC_OPEN:
				{
					OPENFILENAME ofn;
					char szFileName[MAX_PATH] = "";
					char szCurPath[MAX_PATH] = "";

					ZeroMemory(&ofn, sizeof(ofn));

					ofn.lStructSize = sizeof(ofn);
					ofn.hwndOwner = 0;
					ofn.lpstrFilter = "Freelancer Saved Games (*.fl)\0*.fl\0All Files (*.*)\0*.*\0";
					ofn.lpstrFile = szFileName;
					ofn.nMaxFile = MAX_PATH;
					ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
					ofn.lpstrDefExt = "fl";

					if(GetOpenFileName(&ofn))
					{
						char szMoney[255];
						char szSystem[255];
						char szBase[255];
						char szDesc[255];
						char szRank[255];
						char szShiparch[255];
						ResetProgBar(hwnd);
						EnableWindow(GetDlgItem(hwnd, IDC_OPEN), false);
						EnableWindow(GetDlgItem(hwnd, IDC_CLOSE), true);
						EnableWindow(GetDlgItem(hwnd, IDC_SAVE), true);
						EnableWindow(GetDlgItem(hwnd, IDC_ADDCARGO), true);
						SetProgBar(hwnd, 4);
						EnableWindow(GetDlgItem(hwnd, IDC_ADDEQUIP), true);
						EnableWindow(GetDlgItem(hwnd, IDC_EQUIP_HP), true);
						EnableWindow(GetDlgItem(hwnd, IDC_EQUIP_NICK), true);
						EnableWindow(GetDlgItem(hwnd, IDC_CARGO_NICK), true);
						SetProgBar(hwnd, 8);
						EnableWindow(GetDlgItem(hwnd, IDC_CARGO_COUNT), true);
						EnableWindow(GetDlgItem(hwnd, IDC_MONEY), true);
						EnableWindow(GetDlgItem(hwnd, IDC_DESC), true);
						EnableWindow(GetDlgItem(hwnd, IDC_SHIPARCH), true);
						SetProgBar(hwnd, 12);
						EnableWindow(GetDlgItem(hwnd, IDC_SYSTEM), true);
						EnableWindow(GetDlgItem(hwnd, IDC_BASE), true);
						EnableWindow(GetDlgItem(hwnd, IDC_RANK), true);
						EnableWindow(GetDlgItem(hwnd, IDC_CANDOCK), true);
						EnableWindow(GetDlgItem(hwnd, IDC_CANTL), true);
						SetProgBar(hwnd, 17);
						SetDlgItemText(hwnd, IDC_FILENAME, ofn.lpstrFile);
						GetCurrentDirectory(MAX_PATH, szCurPath);
						strcat(szCurPath, "\\temp_save.fl");
						SetProgBar(hwnd, 21);
						flc_decode(ofn.lpstrFile, szCurPath);
						SetProgBar(hwnd, 32);
						GetPrivateProfileString("Player", "money", "???", szMoney, sizeof(szMoney), szCurPath);
						SetDlgItemText(hwnd, IDC_MONEY, szMoney);
						GetPrivateProfileString("Player", "ship_archetype", "???", szShiparch, sizeof(szShiparch), szCurPath);
						SetDlgItemText(hwnd, IDC_SHIPARCH, szShiparch);
						SetProgBar(hwnd, 34);
						GetPrivateProfileString("Player", "system", "???", szSystem, sizeof(szSystem), szCurPath);
						SetDlgItemText(hwnd, IDC_SYSTEM, szSystem);
						GetPrivateProfileString("Player", "base", "???", szBase, sizeof(szBase), szCurPath);
						if(strncmp(szBase, "???", 3) == 0)
						{
							GetPrivateProfileString("Player", "pos", "???", szBase, sizeof(szBase), szCurPath);
							SetDlgItemText(hwnd, IDC_LOCTEXT, "Position:");
							SetDlgItemText(hwnd, IDC_BASE, szBase);
						}
						else
						{
							SetDlgItemText(hwnd, IDC_LOCTEXT, "Base:");
						}
						SetProgBar(hwnd, 36);
						GetPrivateProfileString("Player", "description", "???", szDesc, sizeof(szDesc), szCurPath);
						SetDlgItemText(hwnd, IDC_DESC, szDesc);
						GetPrivateProfileString("Player", "rank", "???", szRank, sizeof(szRank), szCurPath);
						SetDlgItemText(hwnd, IDC_RANK, szRank);
						SetProgBar(hwnd, 38);
						if(GetPrivateProfileInt("mPlayer", "can_dock", 1, szCurPath) == 1)
							SendDlgItemMessage(hwnd, IDC_CANDOCK, BM_SETCHECK, (WPARAM)BST_CHECKED, NULL);
						else
							SendDlgItemMessage(hwnd, IDC_CANDOCK, BM_SETCHECK, (WPARAM)BST_UNCHECKED, NULL);
						if(GetPrivateProfileInt("mPlayer", "can_tl", 1, szCurPath) == 1)
							SendDlgItemMessage(hwnd, IDC_CANTL, BM_SETCHECK, (WPARAM)BST_CHECKED, NULL);
						else
							SendDlgItemMessage(hwnd, IDC_CANDOCK, BM_SETCHECK, (WPARAM)BST_UNCHECKED, NULL);
						SetProgBar(hwnd, 42);
						FILE *tfile = fopen(szCurPath, "r");
						char single_line[255];
						char cargol[] = {0x0A, 'c', 'a', 'r', 'g', 'o'};
						char equipl[] = {0x0A, 'e', 'q', 'u', 'i', 'p'};
						unsigned char chr;
						bool bWrite = false;
						int i=0,p=0;
						SetProgBar(hwnd, 44);
						while(fread(&chr, 1, sizeof(chr), tfile) != 0)
						{
							if(chr == 0x0A) {
								i = 0;
								if(strncmp(cargol, single_line, 6) == 0)
								{
									single_line[0] = 0x20;
									SendDlgItemMessage(hwnd, IDC_CARGOLIST, LB_ADDSTRING, 0, (LPARAM)single_line);
								}
								if(strncmp(equipl, single_line, 6) == 0)
								{
									single_line[0] = 0x20;
									SendDlgItemMessage(hwnd, IDC_EQUIPLIST, LB_ADDSTRING, 0, (LPARAM)single_line);
								}
								memset(single_line, 0x00, sizeof(single_line));
							}
							single_line[i] = chr;
							i++;
							p++;
							SetProgBar(hwnd, 56+p);
						}
						fclose(tfile);
						SendMessage(GetDlgItem(hwnd, IDC_CARGOLIST), LB_SETHORIZONTALEXTENT, (WPARAM)100, 0);
						SendMessage(GetDlgItem(hwnd, IDC_EQUIPLIST), LB_SETHORIZONTALEXTENT, (WPARAM)100, 0);
						ResetProgBar(hwnd);
					}
					else
						MessageBox(hwnd, "Unable to open saved game.", "Error", MB_ICONEXCLAMATION);
				}
				break;
				case IDC_CLOSE:
				{
					char temp_path[MAX_PATH] = "";
					GetCurrentDirectory(MAX_PATH, temp_path);
					strcat(temp_path, "\\temp_save.fl");
					EnableWindow(GetDlgItem(hwnd, IDC_CLOSE), false);
					EnableWindow(GetDlgItem(hwnd, IDC_SAVE), false);
					EnableWindow(GetDlgItem(hwnd, IDC_OPEN), true);
					EnableWindow(GetDlgItem(hwnd, IDC_ADDCARGO), false);
					EnableWindow(GetDlgItem(hwnd, IDC_ADDEQUIP), false);
					EnableWindow(GetDlgItem(hwnd, IDC_EQUIP_HP), false);
					EnableWindow(GetDlgItem(hwnd, IDC_EQUIP_NICK), false);
					EnableWindow(GetDlgItem(hwnd, IDC_CARGO_NICK), false);
					EnableWindow(GetDlgItem(hwnd, IDC_CARGO_COUNT), false);
					EnableWindow(GetDlgItem(hwnd, IDC_MONEY), false);
					EnableWindow(GetDlgItem(hwnd, IDC_DESC), false);
					EnableWindow(GetDlgItem(hwnd, IDC_SHIPARCH), false);
					EnableWindow(GetDlgItem(hwnd, IDC_SYSTEM), false);
					EnableWindow(GetDlgItem(hwnd, IDC_BASE), false);
					EnableWindow(GetDlgItem(hwnd, IDC_RANK), false);
					EnableWindow(GetDlgItem(hwnd, IDC_CANDOCK), false);
					EnableWindow(GetDlgItem(hwnd, IDC_CANTL), false);
					SetDlgItemText(hwnd, IDC_MONEY, NULL);
					SetDlgItemText(hwnd, IDC_SHIPARCH, NULL);
					SetDlgItemText(hwnd, IDC_SYSTEM, NULL);
					SetDlgItemText(hwnd, IDC_BASE, NULL);
					SetDlgItemText(hwnd, IDC_FILENAME, NULL);
					SetDlgItemText(hwnd, IDC_DESC, NULL);
					SetDlgItemText(hwnd, IDC_RANK, NULL);
					SendDlgItemMessage(hwnd, IDC_CANDOCK, BM_SETCHECK, (WPARAM)BST_UNCHECKED, NULL);
					SendDlgItemMessage(hwnd, IDC_CANTL, BM_SETCHECK, (WPARAM)BST_UNCHECKED, NULL);
					SendDlgItemMessage(hwnd, IDC_CARGOLIST, LB_RESETCONTENT, 0, 0);
					SendDlgItemMessage(hwnd, IDC_EQUIPLIST, LB_RESETCONTENT, 0, 0);
					DeleteFile(temp_path);
				}
				break;
				case IDC_SAVE:
				{
					int r = MessageBox(hwnd, "Are you sure you want to save\nthe modified file?", "Confirm", MB_ICONQUESTION+MB_YESNO);
					if(r == IDYES)
					{
						char temp_path[MAX_PATH] = "";
						GetCurrentDirectory(MAX_PATH, temp_path);
						strcat(temp_path, "\\temp_save.fl");
						char file_path[MAX_PATH] = "";
						GetDlgItemText(hwnd, IDC_FILENAME, file_path, sizeof(file_path));
						char szMoney[255];
						char szSystem[255];
						char szBase[255];
						char szDesc[255];
						char szRank[255];
						char szShiparch[255];
						char szLocText[255];
						GetDlgItemText(hwnd, IDC_SHIPARCH, szShiparch, sizeof(szShiparch));
						WritePrivateProfileString("Player", "ship_archetype", szShiparch, temp_path);
						GetDlgItemText(hwnd, IDC_MONEY, szMoney, sizeof(szMoney));
						WritePrivateProfileString("Player", "money", szMoney, temp_path);
						GetDlgItemText(hwnd, IDC_SYSTEM, szSystem, sizeof(szSystem));
						WritePrivateProfileString("Player", "system", szSystem, temp_path);

						GetDlgItemText(hwnd, IDC_LOCTEXT, szLocText, sizeof(szLocText));
						if(strncmp(szLocText, "Base", 4) == 0)
						{
							GetDlgItemText(hwnd, IDC_BASE, szBase, sizeof(szBase));
							WritePrivateProfileString("Player", "base", szBase, temp_path);
						}
						else
						{
							GetDlgItemText(hwnd, IDC_BASE, szBase, sizeof(szBase));
							WritePrivateProfileString("Player", "pos", szBase, temp_path);
						}
						GetDlgItemText(hwnd, IDC_DESC, szDesc, sizeof(szDesc));
						WritePrivateProfileString("Player", "description", szDesc, temp_path);
						GetDlgItemText(hwnd, IDC_RANK, szRank, sizeof(szRank));
						WritePrivateProfileString("Player", "rank", szRank, temp_path);

						if(SendDlgItemMessage(hwnd, IDC_CANDOCK, BM_GETCHECK, NULL, NULL) == BST_CHECKED)
							WritePrivateProfileString("mPlayer", "can_dock", "1", temp_path);
						else
							WritePrivateProfileString("mPlayer", "can_dock", "0", temp_path);
						if(SendDlgItemMessage(hwnd, IDC_CANTL, BM_GETCHECK, NULL, NULL) == BST_CHECKED)
							WritePrivateProfileString("mPlayer", "can_tl", "1", temp_path);
						else
							WritePrivateProfileString("mPlayer", "can_tl", "0", temp_path);
						flc_encode(temp_path, file_path);
						MessageBox(hwnd, "File saved successfully.", "Message", MB_ICONINFORMATION);
					}
				}
				break;
				case IDC_ADDCARGO:
				{
					char temp_file2[MAX_PATH] = "";
					GetCurrentDirectory(MAX_PATH, temp_file2);
					strcat(temp_file2, "\\temp_save.fl");
					char temp_file3[MAX_PATH] = "";
					GetCurrentDirectory(MAX_PATH, temp_file3);
					strcat(temp_file3, "\\temp_save2.fl");
					char szCargoNick[255];
					char szCargoCount[255];
					char szCargoLine[255];
					char szMessage[255];
					char single_line[255];
					unsigned char chr;
					int line = 2;
					int tline = 0;
					int i = 0;
					bool bWrite = false;
					GetDlgItemText(hwnd, IDC_CARGO_NICK, szCargoNick, sizeof(szCargoNick));
					GetDlgItemText(hwnd, IDC_CARGO_COUNT, szCargoCount, sizeof(szCargoCount));
					sprintf(szCargoLine, "\ncargo = %s, %s", szCargoNick, szCargoCount);

					FILE *tfile = fopen(temp_file2, "r");
					FILE *tfile2 = fopen(temp_file3, "w");
					while(fread(&chr, 1, sizeof(chr), tfile) != 0)
					{
						if(chr == 0x0A) {
							i = 0;
							line++;
							memset(single_line, 0x00, sizeof(single_line));
							if(bWrite == true) {
								fprintf(tfile2, szCargoLine);
								bWrite = false;
							}
						}

						fwrite(&chr, 1, sizeof(chr), tfile2);
						single_line[i] = chr;
						i++;
						if(strncmp("\x0Aship_archetype", single_line, 15) == 0 && bWrite == false)
						{
							bWrite = true;
						}
					}
					fclose(tfile);
					fclose(tfile2);
					szCargoLine[0] = ' ';
					SendDlgItemMessage(hwnd, IDC_CARGOLIST, LB_ADDSTRING, 0, (LPARAM)szCargoLine);

					remove(temp_file2);
					rename(temp_file3, temp_file2);

					sprintf(szMessage, "%s of item %s added.", szCargoCount, szCargoNick);
					MessageBox(hwnd, szMessage, "Info", MB_ICONINFORMATION);
				}
				break;
				case IDC_ADDEQUIP:
				{
					char temp_file2[MAX_PATH] = "";
					GetCurrentDirectory(MAX_PATH, temp_file2);
					strcat(temp_file2, "\\temp_save.fl");
					char temp_file3[MAX_PATH] = "";
					GetCurrentDirectory(MAX_PATH, temp_file3);
					strcat(temp_file3, "\\temp_save3.fl");
					char szEquipNick[255];
					char szEquipHp[255];
					char szEquipLine[255];
					char szMessage[255];
					char single_line[255];
					unsigned char chr;
					int line = 2;
					int tline = 0;
					int i = 0;
					bool bWrite = false;
					GetDlgItemText(hwnd, IDC_EQUIP_NICK, szEquipNick, sizeof(szEquipNick));
					GetDlgItemText(hwnd, IDC_EQUIP_HP, szEquipHp, sizeof(szEquipHp));
					sprintf(szEquipLine, "\nequip = %s, %s", szEquipNick, szEquipHp);

					FILE *tfile = fopen(temp_file2, "r");
					FILE *tfile2 = fopen(temp_file3, "w");
					while(fread(&chr, 1, sizeof(chr), tfile) != 0)
					{
						if(chr == 0x0A) {
							i = 0;
							line++;
							memset(single_line, 0x00, sizeof(single_line));
							if(bWrite == true) {
								fprintf(tfile2, szEquipLine);
								bWrite = false;
							}
						}

						fwrite(&chr, 1, sizeof(chr), tfile2);
						single_line[i] = chr;
						i++;
						if(strncmp("\x0Aship_archetype", single_line, 15) == 0 && bWrite == false)
						{
							bWrite = true;
						}
					}
					fclose(tfile);
					fclose(tfile2);
					szEquipLine[0] = ' ';
					SendDlgItemMessage(hwnd, IDC_EQUIPLIST, LB_ADDSTRING, 0, (LPARAM)szEquipLine);

					remove(temp_file2);
					rename(temp_file3, temp_file2);

					sprintf(szMessage, "Item %s equipped to hardpoint %s", szEquipNick, szEquipHp);
					MessageBox(hwnd, szMessage, "Info", MB_ICONINFORMATION);
				}
				break;
            }
        break;
        default:
            return FALSE;
    }
    return TRUE;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
    LPSTR lpCmdLine, int nCmdShow)
{
    DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_MAINDLG), 0, MainDlgProc);
	return 1;
}